<?php
class wootablepressViewWtbp extends viewWtbp {
	public $orderColumns = array();
	public $columnNiceNames = array();

	public function getTabContent() {
		frameWtbp::_()->addStyle('wtbp.admin.css', $this->getModule()->getModPath(). 'css/admin.tables.css');
		frameWtbp::_()->addScript('wtbp.admin.list.js', $this->getModule()->getModPath(). 'js/admin.list.js');
		frameWtbp::_()->addJSVar('wtbp.admin.list.js', 'wtbpTblDataUrl', uriWtbp::mod('wootablepress', 'getListForTbl', array('reqType' => 'ajax')));
		frameWtbp::_()->addJSVar('wtbp.admin.list.js', 'url', admin_url('admin-ajax.php'));
		frameWtbp::_()->addScript('adminCreateTableWtbp', $this->getModule()->getModPath(). 'js/create-table.js');

		frameWtbp::_()->getModule('templates')->loadJqGrid();
		frameWtbp::_()->getModule('templates')->loadFontAwesome();
		frameWtbp::_()->getModule('templates')->loadBootstrapSimple();

		$this->assign('addNewLink', frameWtbp::_()->getModule('options')->getTabUrl('wootablepress#wtbpadd'));

		return parent::getContent('wootablepressAdmin');
	}

	public function getEditTabContent($idIn) {
		$isWooCommercePluginActivated = $this->getModule()->isWooCommercePluginActivated();
		if(!$isWooCommercePluginActivated) {
			return;
		}

		frameWtbp::_()->getModule('templates')->loadBootstrapSimple();
		frameWtbp::_()->getModule('templates')->loadJqueryUi();
		frameWtbp::_()->getModule('templates')->loadCodemirror();

		$this->loadAssets();

		frameWtbp::_()->addScript('wtbp.admin.tables.js', $this->getModule()->getModPath(). 'js/tables.admin.js');
		frameWtbp::_()->addStyle('wtbp.admin.tables.css', $this->getModule()->getModPath(). 'css/admin.tables.css');
		frameWtbp::_()->addStyle('wtbp.frontend.tables.css', $this->getModule()->getModPath(). 'css/frontend.tables.css');
		frameWtbp::_()->addScript('adminCreateTableWtbp', $this->getModule()->getModPath(). 'js/create-table.js');

		dispatcherWtbp::doAction('addScriptsContent', true);

		$idIn = isset($idIn) ? (int) $idIn : 0;
		$table = $this->getModel('wootablepress')->getById($idIn);
		$tableColumns = $this->getModel('columns')->getFullColumnList();
		$settings = unserialize($table['setting_data']);
		$link = frameWtbp::_()->getModule('options')->getTabUrl( $this->getCode() );
		$languages = frameWtbp::_()->getModule('wootablepress')->getModel('languages')->getLanguageBackend();

		$this->assign('languages', $languages);
		$this->assign('link', $link);
		$this->assign('settings', $settings);
		$this->assign('table', $table);
		$this->assign('table_columns', $tableColumns);
		$this->assign('is_pro', frameWtbp::_()->isPro());
		
		return parent::getContent('wootablepressEditAdmin');
	}

	public function renderHtml($params){
		$isWooCommercePluginActivated = $this->getModule()->isWooCommercePluginActivated();
		if(!$isWooCommercePluginActivated) {
			return;
		}

		$this->loadAssets();

		frameWtbp::_()->addScript('frontend.tables.js', $this->getModule()->getModPath(). 'js/tables.frontend.js');
		frameWtbp::_()->addStyle('frontend.tables.css', $this->getModule()->getModPath(). 'css/frontend.tables.css');
		frameWtbp::_()->addJSVar('frontend.tables.js', 'url', admin_url('admin-ajax.php'));
		frameWtbp::_()->addScript('common-js', WTBP_JS_PATH. 'common.js', array(), false, true);
		frameWtbp::_()->addScript('lightbox-js', $this->getModule()->getModPath(). 'js/lightbox.js');
		frameWtbp::_()->addStyle('lightbox-css', $this->getModule()->getModPath(). 'css/lightbox.css');

		dispatcherWtbp::doAction('addScriptsContent', false);

		$id = isset($params['id']) ? (int) $params['id'] : 0;
		if(!$id){
			return false;
		}
		$html = $this->getProductContentFrontend($id);
		$filter = dispatcherWtbp::applyFilters('getTableFilters', '', $id);
		$table = $this->getModel('wootablepress')->getById($id);
		$tableSettings = unserialize($table['setting_data']);
		if(isset($tableSettings['settings']['custom_css']) && !empty($tableSettings['settings']['custom_css'])) {
			$customCss = base64_decode($tableSettings['settings']['custom_css']);
			unset($tableSettings['settings']['custom_css']);
		} else {
			$customCss = '';
		}
		$tableSettings['settings']['order'] = json_encode($this->orderColumns);
		
		$viewId = $id . '_' . mt_rand(0, 999999);
		$this->assign('viewId', $viewId);
		$this->assign('html', $html);
		$this->assign('filter', $filter);
		$this->assign('settings', $tableSettings);
		$this->assign('custom_css', $customCss);

		return parent::getContent('wootablepressHtml');
	}

	public function loadAssets(){
		frameWtbp::_()->addScript('wtbp.dataTables.js', $this->getModule()->getModPath(). 'js/dt/jquery.dataTables.min.js');
		frameWtbp::_()->addScript('wtbp.buttons', $this->getModule()->getModPath(). 'js/dt/dataTables.buttons.min.js');
		frameWtbp::_()->addScript('wtbp.colReorder', $this->getModule()->getModPath(). 'js/dt/dataTables.colReorder.min.js');
		frameWtbp::_()->addScript('wtbp.fixedColumns', $this->getModule()->getModPath(). 'js/dt/dataTables.fixedColumns.min.js');
		frameWtbp::_()->addScript('wtbp.print', $this->getModule()->getModPath(). 'js/dt/buttons.print.min.js');
		frameWtbp::_()->addScript('wtbp.fixedHeader', $this->getModule()->getModPath(). 'js/dt/dataTables.fixedHeader.min.js');
		frameWtbp::_()->addScript('wtbp.scroller', $this->getModule()->getModPath(). 'js/dt/dataTables.scroller.min.js');
		frameWtbp::_()->addScript('wtbp.responsive', $this->getModule()->getModPath(). 'js/dt/dataTables.responsive.min.js');
		frameWtbp::_()->addStyle('wtbp.responsive', $this->getModule()->getModPath(). 'css/dt/responsive.dataTables.min.css');
		frameWtbp::_()->addStyle('wtbp.dataTables.css', $this->getModule()->getModPath(). 'css/dt/jquery.dataTables.min.css');
		frameWtbp::_()->addStyle('wtbp.fixedHeader.css', $this->getModule()->getModPath(). 'css/dt/fixedHeader.dataTables.min.css');
		frameWtbp::_()->addScript('wtbp.core.tables.js', $this->getModule()->getModPath(). 'js/core.tables.js');
		frameWtbp::_()->addJSVar('wtbp.core.tables.js', 'url', admin_url('admin-ajax.php'));
		frameWtbp::_()->addStyle('wtbp.loaders.css', $this->getModule()->getModPath(). 'css/loaders.css');
		frameWtbp::_()->addScript('wtbp.notify.js', WTBP_JS_PATH. 'notify.js', array(), false, true);
	}

	/*private function getTaxonomyHierarchy( $taxonomy, $argsIn ) {
		// only 1 taxonomy
		$taxonomy = is_array( $taxonomy ) ? array_shift( $taxonomy ) : $taxonomy;
		// get all direct decendants of the $parent
		$args = array(
			'orderby'    => 'name',
			'order' => $argsIn['order'],
			'hide_empty' => false,
		);

		if(!empty($argsIn['include'])){
			$args['include'] = $argsIn['include'];
		}
		if(!empty($argsIn['parent']) && $argsIn['parent'] !== 0){
			$args['parent'] = $argsIn['parent'];
		}else{
			$args['parent'] = 0;
		}
		if($taxonomy === ''){
			return false;
		}
		$terms = get_terms( $taxonomy, $args );
		// prepare a new array.  these are the children of $parent
		// we'll ultimately copy all the $terms into this new array, but only after they
		// find their own children
		$children = array();
		// go through all the direct decendants of $parent, and gather their children
		foreach ( $terms as $term ){
			if(!empty($term->term_id)){
				$args = array(
					'orderby'    => 'name',
					'order' => $argsIn['order'],
					'hide_empty' => false,
					'parent' => $term->term_id,
				);

				// recurse to get the direct decendants of "this" term
				$term->children = $this->getTaxonomyHierarchy( $taxonomy, $args );
			}
			// add the term to our new array
			$children[ $term->term_id ] = $term;
		}
		// send the results back to the caller
		return $children;
	}*/

	public function getSearchProductsFilters($args, $params){
		
		$filterCategory = isset($params['filter_category']) ? $params['filter_category'] : 0;
		if(!empty($filterCategory)) {
			$args["tax_query"][] = array(
				'taxonomy' => 'product_cat',
				'field'    => 'id',
				'terms'    => $filterCategory,
				'include_children' => true
			);
		}

		if(!empty($params['search']['value'])){
			$args['s'] = $params['search']['value'];
		}
		return $args;
	}

	public function getSearchProducts($params){
		$dataArr = array();
		$args = array(
			'posts_per_page' => 10,
			'post_type'   => 'product',
			'order'       => 'DESC',
			'suppress_filters' => true,
			'post_status' => array( 'publish' ),
			'offset' => !empty($params['start']) ? $params['start'] : '0'
		);
		$filterInTable = isset($params['filter_in_table']) ? $params['filter_in_table'] : '';
		$ids = isset($params['productids']) ? explode(',', $params['productids']) : [];
		if(sizeof($ids) > 0 && !empty($filterInTable)) {
			$args[$filterInTable == 'no' ? 'post__not_in' : 'post__in'] = $ids;
		}
		$args = $this->getSearchProductsFilters($args, $params);
		
		if(!empty($params['order']['0']['column']) && !empty($params['order']['0']['dir'])){
			switch($params['order']['0']['column']){
				//3 - title columns
				case 3:
					$args['orderby'] = 'title';
					break;
				//6 - price columns
				case 6:
					$args['meta_key'] = '_price';
					$args['orderby'] = 'meta_value_num';
					break;
				//7 - date columns
				case 7:
					$args['orderby'] = 'date';
					break;
			}
			$args['order'] = $params['order']['0']['dir'];
		}
		$products = new WP_Query( $args );

		foreach ( $products->posts as $product ) {
			$thumbnailSrc = get_the_post_thumbnail($product->ID, array(50,50));
			$categories = get_the_term_list( $product->ID, 'product_cat', '', ', ', '' );
			$categories = is_admin() ? str_ireplace('<a', '<a target="_blank"', $categories) : $categories;
			$_product = wc_get_product( $product->ID );
			$price = $_product->get_price_html();
			$date = $product->post_date;
			$id = $product->ID;
			$dataArr[] = array(
				'id' => $id,
				'in_table' => in_array($id, $ids),
				'product_title' => $product->post_title,
				'thumbnail' => $thumbnailSrc,
				'categories' => $categories,
				'sku' => $_product->get_sku(),
				'price' => $price,
				'date' => $date
			);
		}
		$data = $this->generateTableSearchData($dataArr);
		$return = array(
			"draw" => 0,
			"recordsTotal" => $products->found_posts,
			"recordsFiltered" => $products->found_posts,
			'data' => $data
		);
		return $return;
	}

	public function setOrderColumns($orders) {
		$columns = array();
		if($orders !== false && !empty($orders)) {
			$orders = json_decode(stripslashes($orders), true);
			$enabledColumns = $this->getModel('columns')->enabledColumns;
			foreach($orders as $column) {
				$fullSlug = $column['slug'];
				$subDelim = strpos($fullSlug, '-');
				if($subDelim > 0) {
					$column['main_slug'] = substr($fullSlug, 0, $subDelim);
					$column['sub_slug'] = wc_attribute_taxonomy_name_by_id(substr($fullSlug, $subDelim + 1));
				} else {
					$column['main_slug'] = $fullSlug;	
				}
				if(in_array($column['main_slug'], $enabledColumns)) {
					$columns[] = $column;
				}
			}
		}
		$this->orderColumns = $columns;
	}

	public function getProductContentFrontend($id){
		if(empty($id)){
			return false;
		}

		$table = $this->getModel('wootablepress')->getById($id);
		$tableSettings = unserialize($table['setting_data']);
		$productIds = !empty($tableSettings['settings']['productids']) ? $tableSettings['settings']['productids'] : false;
		$this->setOrderColumns(isset($tableSettings['settings']['order']) ? $tableSettings['settings']['order'] : false);
	
		$productIds = explode(",", $productIds);
		if(!empty($productIds) && !is_array($productIds)){
			$productIds = array($productIds);
		}

		$dataArr = $this->getProductContent(array('in' => $productIds, 'not' => false), $tableSettings, true);
		
		wp_reset_postdata();
		$dateAndTimeFormat = $this->getDateTimeFormat($tableSettings);
		$html = $this->generateTableHtml($dataArr, true, $dateAndTimeFormat);

		return $html;
	}

	public function getProductContentBackend($params, $preview = false) {
		$productIdsExits = !empty($params['productIdExist']) ? $params['productIdExist'] : array();
		$productIdsSelected = !empty($params['productIdSelected']) ? $params['productIdSelected'] : array();
		$productIdExcluded = !empty($params['productIdExcluded']) ? $params['productIdExcluded'] : array();
		$productFilters = !empty($params['filters']) ? $params['filters'] : array();
		$filter = $this->getSearchProductsFilters(array(), $productFilters);
		$isAll = $productIdsSelected == 'all';

		if(sizeof($filter) > 0) {
			$args = array_merge(array(
				'post_type' => 'product',
				'ignore_sticky_posts' => true,
				'post_status' => array( 'publish' ),
				'posts_per_page' => -1
			), $filter);
		
			if($isAll) {
				if(sizeof($productIdExcluded) > 0) {
					$args['post__not_in'] = $productIdExcluded;
				}
			} else {
				$args['post__in'] = $productIdsSelected;
			}
			$postExist = new WP_Query($args);

			$products = $productIdsExits;
			foreach($postExist->posts as $post) {
				$products[] = $post->ID;
			}
			$productIds = array('in' => array_unique($products), 'not' => false);
		} else {
			if($isAll) {
				$filtered = array_filter($productIdExcluded,
    				function ($value) use ($productIdsExits) {
        				return !in_array($value, $productIdsExits);
    				}
				);
				$productIds = array('in' => false, 'not' => $filtered);
			} else {
				$productIds = array('in' => array_unique(array_merge($productIdsExits, $productIdsSelected)), 'not' => false);
			}
		}
		if(empty($params['tableid']) || empty($productIds) ){
			return false;
		}
		$tableId = $params['tableid'];

		$table = $this->getModel('wootablepress')->getById($tableId);
		$tableSettings = unserialize($table['setting_data']);
		$this->setOrderColumns(isset($params['order']) ? $params['order'] : false);
		$tableSettings['settings']['order'] = json_encode($this->orderColumns);

		$dataArr = $this->getProductContent($productIds, $tableSettings, $preview);

		$postIdsReturn = '';
		$count = count($dataArr);
		$i = 1;
		foreach ($dataArr as $data){
			if($count === $i){
				$postIdsReturn .= $data['id'];
			}else{
				$postIdsReturn .= $data['id'] . ',';
			}
			$i++;
		}
		$dateAndTimeFormat = $this->getDateTimeFormat($tableSettings);
		$html = $this->generateTableHtml($dataArr, $preview, $dateAndTimeFormat);

		$return = array();
		$return['html'] = $html;
		$return['filter'] = dispatcherWtbp::applyFilters('getTableFilters', '', $tableId);
		$return['settings'] = $tableSettings;
		$return['ids'] = $postIdsReturn;

		return $return;
	}

	public function getProductContent($productIds, $tableSettings, $preview = true) {

		$frontend = !is_admin() || $preview;
		$orders = $this->orderColumns;

		$args = array(
			//'post__in' => $productIds,
			'post_type' => 'product',
			'ignore_sticky_posts' => true,
			'post_status' => array( 'publish' ),
			'posts_per_page' => -1
		);
		if(is_array($productIds['in'])) {
			$args['post__in'] = $productIds['in'];
		} else if(is_array($productIds['not'])) {
			$args['post__not_in'] = $productIds['not'];
		}

		$dataExist = new WP_Query( $args );
		$postExist = $dataExist->posts;
		$settings = isset($tableSettings['settings']) ? $tableSettings['settings'] : array();

		if($frontend){
			$imgSize = !empty($settings['thumbnail_size']) ? $settings['thumbnail_size'] : 'thumbnail';
			if($imgSize == 'set_size') {
				$imgSize = array(
					(!empty($settings['thumbnail_width']) ? $settings['thumbnail_width'] : 0),
					(!empty($settings['thumbnail_height']) ? $settings['thumbnail_height'] : 0)
				);
			}
		}
		
		$stockNames = wc_get_product_stock_status_options();
		//$cartUrl = wc_get_cart_url();
		//$taxonomies = array();
		$dataArr = array();
	
		foreach($postExist as $post) {
			$id = $post->ID;
			$_product = wc_get_product($id);
			$sku = $_product->get_sku();
			$data = array('id' => $id);
			foreach($orders as $column) {
				$slug = $column['slug'];
				switch ($column['main_slug']) {
					case 'thumbnail':
						if($frontend) {
							$postThumbnailId = get_post_thumbnail_id( $post );
							$postImg = wp_get_attachment_image( $postThumbnailId, $imgSize );
							$postImgSrc = wp_get_attachment_image_src( $postThumbnailId, 'full' );
							$data['thumbnail'] = '<a href="'.$postImgSrc[0].'" data-lightbox="'.$post->ID.'">' . $postImg . '</a>';
						} else {
							$data['thumbnail'] = get_the_post_thumbnail($id, 'thumbnail');
						}
						break;
					case 'product_title':
						$data['product_title'] = $post->post_title;
						break;
					case 'featured':
						$data['featured'] = ($_product->get_featured() ? __('Featured', 'woocommerce') : '');
						break;
					case 'sku':
						$data['sku'] = $sku;
						break;
					case 'categories':
						$categories = get_the_term_list($id, 'product_cat', '', ', ', '');
						$data['categories'] = $frontend ? $categories : str_ireplace('<a', '<a target="_blank"', $categories);
						break;
					case 'description':
						$postContent = $post->post_content;
						if($frontend){
							$postContent = strip_tags(mb_strimwidth($post->post_content, 0, 100, "..."));
						}
						$data['description'] = $postContent;
						break;
					case 'reviews':
						$reviews = '';
						if($average = $_product->get_average_rating()) {
							$reviews .= '<div class="star-rating" title="'.sprintf(__( 'Rated %s out of 5', 'woocommerce' ), $average).'"><span style="width:'.(($average / 5) * 100) . '%"><strong itemprop="ratingValue" class="rating">'.$average.'</strong> '.__('out of 5', 'woocommerce').'</span></div>';
						}
						$data['reviews'] = $reviews;
						break;
					case 'stock':
						$data['stock'] = $stockNames[$_product->get_stock_status()];
						break;
					case 'date':
						$data['date'] = $post->post_date;
						break;
					case 'price':
						$data['price'] = $_product->get_price_html();
						break;
					default:
						$data = dispatcherWtbp::applyFilters('getColumnContent', $data, array('column' => $column, 'product' => $_product, 'frontend' => $frontend, 'settings' => $settings));
						break;
				}
			}
			$dataArr[] = $data;
		}
		return $dataArr;
	}
	
	public function getColumnNiceName($slug){
		if(empty($this->columnNiceNames)) {
			$orders = $this->orderColumns;
			$names = array();
			if(empty($orders)) {
				$tableColumns = $this->getModel('columns')->getFromTbl();
				foreach($tableColumns as $columns) {
					$names[$columns['columns_name']] = $columns['columns_nice_name'];
				}
			} else {
				foreach($orders as $order) {
					$name = (!empty($order['show_display_name']) && $order['show_display_name'] === '1') ? $order['display_name'] : $order['original_name'];
					$names[$order['slug']] = $name;
				}
			}
			$this->columnNiceNames = $names;
		}
		return array_key_exists($slug, $this->columnNiceNames) ? $this->columnNiceNames[$slug] : $slug;
	}

	public function sortProductColumns($listPost){
		$orders = $this->orderColumns;
		$sortArray = array();
		$sortArray[] = 'id';
		$sortArray[] = 'check_multy';
		if(!empty($orders)){
			foreach ($orders as $order){
				$sortArray[] = $order['slug'];
			}
		}else{
			$orders = array('product_title', 'thumbnail', 'categories', 'price', 'date');
			foreach ($orders as $order){
				$sortArray[] = $order;
			}
		}
		$sortedPostList = array();

		foreach ($sortArray as $order) {
			$i = 0;
			foreach ($listPost as $key=>$post) {
				if (is_array($post) && array_key_exists($order, $post)) {
					$sortedPostList[$key][$order] = $post[$order];
					$i++;
				}
			}
		}
		return $sortedPostList;
	}

	public function generateTableHtml($listPost, $preview = false, $dateAndTimeFormat = false){
		$listPost = $this->sortProductColumns($listPost);
		if($preview){
			$tableHeader = '<thead><tr>';
			$tableBody = '<tbody>';
			$tableFooter = '<tfoot><tr>';
		}else{
			$tableHeader = '<thead><tr><th class="no-sort"><input class="wtbpCheckAll" type="checkbox"/></th>';
			$tableBody = '<tbody>';
			$tableFooter = '<tfoot><tr><th class="no-sort"><input class="wtbpCheckAll" type="checkbox"/></th>';
		}
		for($i = 0; $i<count($listPost); $i++){

			$k = 1;
			if($i === 0){
				foreach ($listPost[$i] as $key=>$post){
					if($k !== 1){
						$niceName = $key == 'check_multy' ? '<input type="checkbox" class="wtbpAddMultyAll">': $this->getColumnNiceName($key);
						$tableHeader .=  '<th data-key="'.$key.'">'.$niceName.'</th>';
						$tableFooter .=  '<th data-key="'.$key.'">'.$niceName.'</th>';
					}
					$k++;
				}
				$countKeys = count($listPost[$i]);
			}

			$j = 1;

			foreach ($listPost[$i] as $key=>$post){
				if($j === 1){
					if($preview){
						$tableBody .=  '<tr>';
					}else{
						$tableBody .=  '<tr><td><input type="checkbox" data-id="'.$post.'"></td>';
					}
				}else{
					if($key === 'date' && $dateAndTimeFormat){

						$date = $post;
						$dateTimestamp = strtotime($date);
						$outputDate = date($dateAndTimeFormat, $dateTimestamp);

						$tableBody .=  '<td data-order="'.$dateTimestamp.'" class="'.$key.'"><div class="wtbpNoBreak">'.$outputDate.'</div></td>';
					}else if($key === 'product_title'){
						$url = get_permalink( $listPost[$i]['id'] ) ;
						$tableBody .=  '<td class="'.$key.'"><a href="'. $url .'">'. $post .'</a></td>';
					}else{
						$tableBody .=  '<td class="'.$key.'">'.$post.'</td>';
					}
				}
				if($j === $countKeys){
					$tableBody .=  '</tr>';
				}
				$j++;
			}
		}


		$tableHeader .= '</tr></thead>';
		$tableBody .= '</tbody>';
		$tableFooter .= '</tr></tfoot>';

		$table = $tableHeader . $tableFooter . $tableBody;

		return $table;
	}

	public function generateTableSearchData($listPost){
		$table = array();
		$yes = __('yes', WTBP_LANG_CODE);
		$no = __('no', WTBP_LANG_CODE);
		foreach ($listPost as $post){
			$table[] = array(
				'0' => '<input type="checkbox" data-id="'.$post['id'].'">',
				'1' => ($post['in_table'] ? '<label class="wtbpPropuctInTable">'.$yes.'</label>' : $no),
				'2' => $post['thumbnail'],
				'3' => $post['product_title'],
				'4' => $post['categories'],
				'5' => $post['sku'],
				'6' => $post['price'],
				'7' => $post['date'],
			);
		}
		return $table;
	}

	public function getDateTimeFormat($tableSettings) {

		$dateFormat = !empty($tableSettings['settings']['date_formats']) ? $tableSettings['settings']['date_formats'] : false;
		$timeFormat = !empty($tableSettings['settings']['time_formats']) ? $tableSettings['settings']['time_formats'] : false;
		$dateAndTimeFormat = false;
		if($timeFormat && $dateFormat){
			$dateAndTimeFormat = $dateFormat . ' ' . $timeFormat;
		}else if($dateFormat){
			$dateAndTimeFormat = $dateFormat;
		}else if($timeFormat){
			$dateAndTimeFormat = $timeFormat;
		}
		return $dateAndTimeFormat;
	}

	public function showEditTablepressFormControls() {
		parent::display('wootablepressEditFormControls');
	}

}
